;-------------------------------------------------------------------------
;A function that finds out if a line segment and a plane intersect
;and calculates the intersection point in the array picked(2)
;where picked(0)=pickedx,..1=y,..2=z
;
;After a tutorial by Paul Bourke.
;
;by elias_t
;
;-------------------------------------------------------------------------

;stores the picked location
Dim picked#(2)



Function ray_plane(p1x#,p1y#,p1z#, p2x#,p2y#,p2z#, pax#,pay#,paz#, pbx#,pby#,pbz#, pcx#,pcy#,pcz#)

Local d#
Local total#,denom#,mu#
Local nx#,ny#,nz#

				
Local dx1#=(pcx - pax)
Local dy1#=(pcy - pay)
Local dz1#=(pcz - paz)

Local dx2#=(pbx - pax)
Local dy2#=(pby - pay)
Local dz2#=(pbz - paz)

nx#=(dy1*dz2)-(dz1*dy2)
ny#=(dz1*dx2)-(dx1*dz2)
nz#=(dx1*dy2)-(dy1*dx2)

;------------------------------------



   d = - nx * pax - ny * pay - nz * paz

   ;Calculate the position on the Line that intersects the plane
   denom = nx * (p2x - p1x) + ny * (p2y - p1y) + nz * (p2z - p1z);

   If (Abs(denom) < 0.0001) Return 0;Line And plane don't intersect
      
   mu = - (d + nx * p1x + ny * p1y + nz * p1z) / denom
   picked(0) = p1x + mu * (p2x - p1x)
   picked(1) = p1y + mu * (p2y - p1y)
   picked(2) = p1z + mu * (p2z - p1z)
	
	;comment this out if you want an infinite ray
   If (mu < 0 Or mu > 1) Return 0;Intersection Not along Line segment
      
   Return 1

End Function

















;-------------------------------------------------------------------------
;EXAMPLE
;quick and messy but works ok.

Graphics3D 640,480,32,2

cam=CreateCamera()
CameraRange cam,1,20000
PositionEntity cam,0,5,-10
li=CreateLight()

;start and end point of line segment
p1x#=0:p1y#=10:p1z#=-10
p2x#=-120:p2y#=-500:p2z#=1000



;visualize the triangle that defines a plane
m=CreateMesh()
s=CreateSurface(m)
v0=AddVertex(s,1,0,0)
v1=AddVertex(s,0,0,1)
v2=AddVertex(s,-1,0,0)
v3=AddVertex(s,0,0,-1);extra vert to make a plane
AddTriangle (s,v0,v2,v1)

EntityColor m,0,255,0
UpdateNormals m




RotateMesh m,20,0,30
ScaleMesh m,400,400,400

;3 vertexes of the triangle that define a plane
v0x#=VertexX(s,v0):v0y#=VertexY(s,v0):v0z#=VertexZ(s,v0)
v1x#=VertexX(s,v1):v1y#=VertexY(s,v1):v1z#=VertexZ(s,v1)
v2x#=VertexX(s,v2):v2y#=VertexY(s,v2):v2z#=VertexZ(s,v2)




;create the visual ray
test=CopyMesh(m)
EntityColor test,255,255,0
EntityFX test,16

s1=GetSurface(test,1)

;the +-.2 is for visualisation purposes
VertexCoords(s1,0,p1x+.2,p1y,p1z)
VertexCoords(s1,1,p2x,p2y,p2z)
VertexCoords(s1,2,p1x-.2,p1y,p1z)


PositionEntity cam,0,15,-10
PointEntity cam ,m


;intersction pointer
cc=CreateCube()
EntityColor cc,255,0,0
ScaleEntity cc,.2,.2,.2

;add the extra tri to make a plane
AddTriangle (s,v0,v3,v2)
UpdateNormals m

While Not KeyHit(1)

RenderWorld()

If KeyDown(200) Then VertexCoords(s1,1,VertexX(s1,1),VertexY(s1,1)+1,VertexZ(s1,1))
If KeyDown(208) Then VertexCoords(s1,1,VertexX(s1,1),VertexY(s1,1)-1,VertexZ(s1,1))

If KeyDown(203) Then VertexCoords(s1,1,VertexX(s1,1)-1,VertexY(s1,1),VertexZ(s1,1))
If KeyDown(205) Then VertexCoords(s1,1,VertexX(s1,1)+1,VertexY(s1,1),VertexZ(s1,1))

If KeyDown(201) Then VertexCoords(s1,1,VertexX(s1,1),VertexY(s1,1),VertexZ(s1,1)+1)
If KeyDown(209) Then VertexCoords(s1,1,VertexX(s1,1),VertexY(s1,1),VertexZ(s1,1)-1)


dx#=VertexX(s1,1)
dy#=VertexY(s1,1)
dz#=VertexZ(s1,1)

res=ray_plane(p1x,p1y,p1z, dx,dy,dz  ,v0x,v0y,v0z,v1x,v1y,v1z,v2x,v2y,v2z)
Text 10,10,res


If res
PositionEntity cc,picked(0),picked(1),picked(2),1
Text 10,100,picked(0)
Text 10,120,picked(1)
Text 10,140,picked(2)
EndIf



Flip

Wend


End